//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                                                         e-PSI@ManagerTrailing.mq4 |
//|                                    Copyright  2010-13, Igor Stepovoi aka TarasBY |
//|                                                                taras_bulba@tut.by |
//|                                                                                   |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|        .  -  |
//|      (TarasBY).      |
//|       ,    .    |
//|         .                            |
//|         ,    - |
//| .                                                             |
//|     ,     ,    |
//|     Skype: TarasBY  e-mail.                          |
//+-----------------------------------------------------------------------------------+
//|   This product is intended for non-commercial use.  The publication is only allo- |
//|wed when you specify the name of the author (TarasBY). Edit the source code is va- |
//|lid only under condition of preservation of the text, links and author's name.     |
//|   Selling a expert or(and) parts of it PROHIBITED.                                |
//|   The author is not liable for any damages resulting from the use of a expert.    |
//|   For all matters relating to the work of the expert, comments or suggestions for |
//|their improvement in the contact Skype: TarasBY or e-mail.                         |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
#property copyright "Copyright  2008-13, TarasBY WM R418875277808; Z670270286972"
#property link      "taras_bulba@tut.by"
//IIIIIIIIIIIIIIIIIII========== ==========IIIIIIIIIIIIIIIIIIIIII+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  *****                   *****                  |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
extern string   SETUP_Expert        = "==========    ==========";
extern int      NumberAccount          = 0;             //   .     .   <=0 -     
extern int      MG                     = 880;           // : < 0 -  ( ), 0 -  , > 0 -   ()
extern datetime TimeControl            = D'2013.01.01 00:00';//        
extern int      NewBarInPeriod         = -1;            // <= 0 -      , -1 -    
#include        <b-PSI@Base.mqh>                        //   
extern bool     OnlyCurrentSymbol      = TRUE;          //        List_Symbols
extern string   List_Symbols           = "EURUSD,GBPUSD";//   
extern int      NBars_LifeMIN          = 0;             //  ""   NBars_LifeMIN    
extern int      NBars_LifeMAX          = -1;            //  ""   NBars_LifeMAX     (0 -      )
#include        <b-PSI@STOPs_Light.mqh>                 //     
#include        <b-PSI@TrailSymbol.mqh>                 //  
#include        <b-PSI@PartClose_Light.mqh>             //    
#include        <b-PSI@ManagerPA.mqh>                   //      
extern string   Setup_Services      = "=================== SERVICES ==================";
extern bool     ShowCommentInChart     = TRUE;          //  . 
extern bool     PrintCom               = TRUE;          //  .
extern bool     SoundAlert             = FALSE;         // 
extern bool     CreatVStopsInChart     = FALSE;         //      ( )
extern bool     ClearALLAfterTrade     = FALSE;         //    GV-  
#include        <b-PSI@Trade_Light.mqh>                 //   
extern string   Setup_Tester        = "=================== Tester ====================";
extern int      InTesterOrder          = 1;             //      . 1 - , -1 -  
//IIIIIIIIIIIIIIIIIII======  ======IIIIIIIIIIIIIIIIIIIIII+
string          gs_Base, gs_Info;
int             gi_SL = 200, gia_HistoryOrders[3], gia_MyOrders[2];
bool            flag_BadAccount = false, gb_Pause = false;
//IIIIIIIIIIIIIIIIIII========== ==========IIIIIIIIIIIIIIIIIIIIII+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  Custom expert initialization function                            |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int init()
{
    int err = GetLastError();
//----
    //----    
    if (!fCheck_MyAccount()) return (0);
    //----      
    if (!fCheck_ExternParameters()) {bb_OptimContinue = true; return (0);}
    //----    
    fInit_Base (List_Symbols, MG, Period(), ShowCommentInChart, PrintCom, SoundAlert, CreatVStopsInChart);
    //----     
    if (!fInit_ManagerPA()) return (0);
    //----   
    if (!fInit_STOPs()) return (0);
    //----    
    if (!fInit_PartClose()) return (0);
    //----   
    if (!fInit_Trail (fGet_PeriodFromNum (fGet_NumPeriods (TF_STOPs) + 1))) return (0);
    //----   
    fGet_Statistic (-1);
    //----   
    fCheck_Decimal();
    if (OnlyCurrentSymbol || !bb_RealTrade) {bs_SymbolList = Symbol();}
    bs_ExpertName = StringConcatenate (WindowExpertName(), "[", IIFs (MG >= 0, MG, "ALL"), "]:  ", fGet_NameTF (Period()), "_", Symbol());
    //----      
    bdt_BeginTrade = fGet_TermsTrade (bdt_LastTrade);
    //----  
    fPrepareComments();
    //----  GV-
    if (!bb_RealTrade)
    {
        GlobalVariablesDeleteAll (bs_NameGV);
        TimeControl = D'1990.01.01 00:00';
    }
    if (!bb_VirtualTrade) {if (bb_OptimContinue) Alert (" !     !!!");}
    //----   
	 fGet_LastErrorInArray (bsa_Comment, "init()", bi_indERR);
//----
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  Custor expert deinitialization function                          |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int deinit()
{
//----
    fMineDeInit();
//----
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|               Custom expert iteration function                                    |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int start()
{
    if (flag_BadAccount) {return (0);}
    //----    
    if (fSTOPTRADE()) return (0);
//----
    int err = GetLastError();
//----
    //----     
    fOrderSend_Tester();
    //----  "" 
    bi_MyOrders = fMyPositions (bd_ProfitCUR);
    //----  
    fGet_Statistic (PERIOD_D1);
    //----       
    fCheck_MyIndicatorsSTOP (bs_Symbol);
    //----     ( )
    if (ShowCommentInChart) {fCommentInChart (bsa_Comment, fGet_StringManagerPA());}
    //----      ( NewBarInPeriod >= 0)
    if (!fCheck_NewBarInPeriod (NewBarInPeriod)) return (0);
    //----        
    if (fManagerPA (bd_ProfitCUR, bd_Balance, bi_MyOrders > 0)) bi_MyOrders = 0;
    //----    
    if (!bb_TSProfit) {if (bi_MyOrders > 0) fControl_Positions();}
    bb_first = false;
    //----   
	 fGet_LastErrorInArray (bsa_Comment, "start()", bi_indERR);
//----
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|          ""                                   |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int fMyPositions (double& fd_Profit)      //    
{
    int li_ord = 0, li_total = OrdersTotal();
//----
    fd_Profit = 0.0;
    ArrayInitialize (gia_MyOrders, 0);
    if (li_total == 0) {return (0);}
    for (int li_pos = li_total - 1; li_pos >= 0; li_pos--)
    {
        if (!fCheck_MyOrders (li_pos, -2)) continue;
        fd_Profit += (OrderProfit() + OrderSwap() + OrderCommission());
        gia_MyOrders[OrderType()]++;
        li_ord++;
    }
//----
    return (li_ord);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//+===================================================================================+
//|***********************************************************************************|
//| :                                                            |
//|***********************************************************************************|
//+===================================================================================+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|         ""                                       |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fControl_Positions()
{
    int      li_Type, li_Ticket, li_LifeBar, err = GetLastError();
    double   ld_Profit;
    bool     lb_NewBar = false;
    datetime ldt_BeginBar = fGet_SymbolTime (Symbol(), TF_STOPs, 0);
    static datetime ldt_NewBar = 0;
//----
    if (ldt_NewBar != ldt_BeginBar) lb_NewBar = true;
    for (int li_pos = OrdersTotal() - 1; li_pos >= 0; li_pos--)
    {
        if (!fCheck_MyOrders (li_pos, -2)) continue;
        li_Ticket = OrderTicket();
        li_LifeBar = iBarShift (Symbol(), TF_STOPs, OrderOpenTime());
        //----     
        fGet_MarketInfo (OrderSymbol(), li_Ticket);
        //----      
        if (fControl_MAXLife (li_LifeBar, NBars_LifeMAX)) continue;
        //----    
        if (fUSE_VSTOP (li_Ticket, NBars_LifeMIN, li_LifeBar, Slippage, USE_Dinamic_TP)) continue;
        //----   
        if (fCreat_STOPs (N_STOPs, li_Ticket, bda_Price[bi_Type], TF_STOPs, lb_NewBar, USE_VirtualSTOPs)) continue;
        //----   
        if (fTrail_Position (li_Ticket, Slippage) == 0) continue;
        if (!PartClose_ON) continue;
        ld_Profit = OrderProfit() + OrderCommission() + OrderSwap();
        //----    
        if (ld_Profit > 0.0) {fPartClose (li_Ticket, Slippage, USE_VirtualSTOPs);}
    }
    if (lb_NewBar) ldt_NewBar = ldt_BeginBar;
    //----   
    fGet_LastErrorInArray (bsa_Comment, "fControl_Positions()", bi_indERR);
//----
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                           |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
bool fIs_LossLastPos()
{
    datetime ldt_CloseTime;
    int li_Ticket = -1, li_total = OrdersHistoryTotal();
//----
    for (int li_ORD = li_total - 1; li_ORD >= 0; li_ORD--)
    {
        if (!fCheck_MyOrders (li_ORD, -2, MODE_HISTORY)) continue;
        if (ldt_CloseTime >= OrderCloseTime()) continue;
        ldt_CloseTime = OrderCloseTime();
        li_Ticket = OrderTicket();
    }
    if (OrderSelect (li_Ticket, SELECT_BY_TICKET, MODE_HISTORY))
    {if (OrderProfit() < 0) return (True);}
//----
    return (False);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//+===================================================================================+
//|***********************************************************************************|
//| :                                                               |
//|***********************************************************************************|
//+===================================================================================+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                      |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fCheck_Decimal()
{
//----
    gi_SL *= bi_Decimal;
//----
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//              .                         |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
bool fCheck_ExternParameters()
{
//----
    bs_ERROR = "";
    //----     
    if (!IsTesting()) {if (!IsOptimization()) if (!IsExpertEnabled()) return (false);}
    //----   GV- 
    bs_NameGV = "ManagerTrailing";
    if (NewBarInPeriod == 0) NewBarInPeriod = Period();
    //----     
    bdt_NewBarInPeriod = fGet_SymbolTime (Symbol(), MathMax (0, NewBarInPeriod), 1);
//----
    return (true);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                           |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fMineDeInit()
{
//----
    //----    GV-
    if (!bb_RealTrade) {GlobalVariablesDeleteAll (bs_NameGV);}
    //----    
    if (ClearALLAfterTrade)
    {
        Comment ("");
        //----     
        fObjectsDeleteAll (bs_NameGV, -1, 0); 
        //----  GV-
        GlobalVariablesDeleteAll (bs_NameGV);
    }
    else
    {
        //----   
        fGet_Statistic (-1);
        //----    
        if (ShowCommentInChart) {fCommentInChart (bsa_Comment, fGet_StringManagerPA());}
    }
    //----   
    for (int li_IND = 0; li_IND < 3; li_IND++)
    {if (ObjectFind ("STOP" + li_IND) == 0) ObjectDelete ("STOP" + li_IND);}
//----
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//+===================================================================================+
//|***********************************************************************************|
//| : MONEY MANAGEMENT                                                          |
//|***********************************************************************************|
//+===================================================================================+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                   |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double fCalculate_Pribul (int& ar_HistoryOrders[3],    //        
                          int fi_OP = -2,              //  (BUY\SELL)  
                          datetime fdt_TimeBegin = 0)  //  ,    
{
    double   ld_Pribul = 0.0;
    int      li_Type, history_total = OrdersHistoryTotal(), li_Ticket,
             err = GetLastError();
    datetime ldt_preLastTrade = bdt_LastTrade - 1209600;
//----
    ArrayInitialize (ar_HistoryOrders, 0);
    for (int li_ORD = 0; li_ORD < history_total; li_ORD++)
    {
        if (!fCheck_MyOrders (li_ORD, fi_OP, MODE_HISTORY)) continue;
        if (fdt_TimeBegin > OrderCloseTime()) continue;
        li_Type = OrderType();
        ld_Pribul += (OrderProfit() + OrderSwap() + OrderCommission());
        ar_HistoryOrders[2]++;
        ar_HistoryOrders[li_Type]++;
        if (bdt_LastTrade < OrderCloseTime()) bdt_LastTrade = OrderCloseTime();
        //----   GV-   2-
        if (!bb_ClearGV) continue;
        if (ldt_preLastTrade >= OrderCloseTime()) continue;
        li_Ticket = OrderTicket();
        //----       
        if (fTransmit_Sets (li_Ticket)) continue;
        //----   GV-
        fClear_WasteGV (bsa_prefGV, li_Ticket);
    }
    //----   
	 fGet_LastErrorInArray (bsa_Comment, "fCalculate_Pribul()", bi_indERR);
//----
    return (ld_Pribul);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                                 |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fGet_Statistic (int fi_Period = 0,           //   (TF)    
                     bool fb_IsTimeGMT = false)   //   
{
    static datetime ldt_NewBar = 0;
    static int      li_PreHistOrders = 0;
    int      li_ORD, err = GetLastError(), li_Period =  MathMax (0, fi_Period);
    bool     lb_CondON = true;
    datetime ldt_NewPeriod = fGet_SymbolTime (Symbol(), li_Period, 0);
//----
    //----    " "
    bdt_curTime = TimeCurrent();
    bd_Balance = AccountBalance();
    bd_Equity = AccountEquity();
    bd_FreeMargin = AccountFreeMargin();
    bd_Margin = AccountMargin();
    //----     
    if (ldt_NewBar == ldt_NewPeriod) if (li_PreHistOrders == OrdersHistoryTotal()) if (fi_Period >= 0)
    {lb_CondON = false;}
    if (lb_CondON)
    {
        li_PreHistOrders = OrdersHistoryTotal();
        ldt_NewBar = ldt_NewPeriod;
        //----   
        bd_Pribul = fCalculate_Pribul (gia_HistoryOrders, -2, TimeControl);
    }
    //----   
	 fGet_LastErrorInArray (bsa_Comment, "fGet_Statistic()", bi_indERR);
//----
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                    |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
bool fTransmit_Sets (string fs_Ticket)    // Ticket
{
    string ls_Name, ls_NameChild;
    int    li_ChildTicket = fGet_hildTicket (OrderComment());
    static string lsa_NameGV[] = {"_#VirtSL","_#VirtTP","_#BU","_#STOP"};
//---- 
    //----    ,    
    if (li_ChildTicket == 0) return (false);
    if (!OrderSelect (li_ChildTicket, SELECT_BY_TICKET)) return (false);
    //----    -  
    if (OrderCloseTime() > 0) return (false);
    for (int li_GV = 0; li_GV < 4; li_GV++)
    {
        //----       
        ls_Name = StringConcatenate (fs_Ticket, lsa_NameGV[li_GV]);
        if (!GlobalVariableCheck (ls_Name)) continue;
        ls_NameChild = StringConcatenate (li_ChildTicket, lsa_NameGV[li_GV]);
        if (GlobalVariableCheck (ls_NameChild)) continue;
        GlobalVariableSet (ls_NameChild, GlobalVariableGet (ls_Name));
    }
//----
    return (true);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|            GV-                             |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fClear_WasteGV (string ar_NameGV[],  //     GV-
                     string fs_Ticket)    // Ticket
{
    string ls_Name;
    int    li_size = ArraySize (ar_NameGV);
//---- 
    for (int li_IND = 0; li_IND < li_size; li_IND++)
    {
        ls_Name = StringConcatenate (fs_Ticket, ar_NameGV[li_IND]);
        if (GlobalVariableCheck (ls_Name)) GlobalVariableDel (ls_Name);
    }
//---- 
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|         Ticket                                             |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int fGet_hildTicket (string fs_Comment)
{
    int li_N1 = StringFind (fs_Comment, "to");
//----
    if (li_N1 >= 0)
    {
        int li_N2 = StringFind (fs_Comment, "#");
        if (li_N2 > li_N1)
        {return (StrToInteger (StringSubstr (fs_Comment, li_N2 + 1, StringLen (fs_Comment) - li_N2 - 1)));}
    }
//----
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//+===================================================================================+
//|***********************************************************************************|
//| :                                                           |
//|***********************************************************************************|
//+===================================================================================+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                            |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fCommentInChart (string& ar_Comment[],      //   
                      string fs_ManagerPA = "")  //        
{
    static string lsa_Time[], lsa_Comment[], ls_BeginTrade,
                  ls_row = "\n",
                  ls_PSI = " PSITarasBY \n";
    static int    li_size, li_size_CommTime, li_Period = 60;
    string ls_CTRL = "", ls_BLOCK_Comment, ls_Comment = "",
           ls_Error = "", ls_time = "", ls_sign, ls_TermsTrade;
//----
    //----      
    if (bb_first)
    {
        li_Period *= NewBarInPeriod;
        li_size = ArraySize (ar_Comment);
        ArrayResize (lsa_Time, li_size);
        ArrayResize (lsa_Comment, li_size);
        InitializeArray_STR (lsa_Comment, "");
        InitializeArray_STR (lsa_Time, "");
        ls_BeginTrade = StringConcatenate ("Terms Trade :: Begin - ", TimeToStr (bdt_BeginTrade));
        //bdt_NewBarInPeriod = fGet_SymbolTime (Symbol(), NewBarInPeriod, 0);
    }
    //----  
    for (int li_MSG = 0; li_MSG < li_size; li_MSG++)
    {
        //----    
        if (StringLen (ar_Comment[li_MSG]) > 0)
        {
            if (ar_Comment[li_MSG] != lsa_Comment[li_MSG]) {lsa_Comment[li_MSG] = ar_Comment[li_MSG];}
            if (li_MSG == li_size - 1) {ls_sign = "";} else {ls_sign = " : ";}
            lsa_Time[li_MSG] = StringConcatenate (TimeToStr (bdt_curTime), ls_sign);
            ar_Comment[li_MSG] = "";
        }
        //----   
        if (li_MSG < li_size - 1)
        {if (StringLen (lsa_Comment[li_MSG]) > 0) {ls_Comment = StringConcatenate (ls_Comment, lsa_Time[li_MSG], lsa_Comment[li_MSG], "\n");}}
        //----   
        else if (li_MSG == li_size - 1)
        {
            //----  2     
            if (bdt_curTime > StrToTime (lsa_Time[li_MSG]) + 7200)
            {lsa_Comment[li_MSG] = "";}
            if (StringLen (lsa_Comment[li_MSG]) > 0) {ls_Error = StringConcatenate (ls_row, "ERROR:  ", lsa_Time[li_MSG], "\n", lsa_Comment[li_MSG]);}
        }
    }
    //----      
    ls_time = StringConcatenate ("\nTime :: cur ", TimeToStr (bdt_curTime, TIME_DATE|TIME_SECONDS), " | local ", TimeToStr (TimeLocal(), TIME_MINUTES|TIME_SECONDS));
    if (NewBarInPeriod > 0) {ls_time = StringConcatenate (TimeToStr (bdt_NewBarInPeriod + li_Period), ls_time);}
    ls_TermsTrade = StringConcatenate (ls_BeginTrade, " | Last - ", TimeToStr (bdt_LastTrade), "\n");
    //----    
    ls_BLOCK_Comment = StringConcatenate (bs_ExpertName, "\n", ls_row, gs_Info, "\n",
                 gs_Base, ls_time, "\n",
                 ls_TermsTrade,
                 ls_row,
                 //----   
                 "          PROFIT    = ", bs_sign, " ", fSplitField (DoubleToStr (bd_ProfitCUR, 1)), " | ", DoubleToStr (bd_ProfitPercent - 100.0, 1), " % [ ", bi_MyOrders, " | ", gia_MyOrders[0], " / ", gia_MyOrders[1], " ]\n",
                 //----     
                 fs_ManagerPA,
                 "          RESULT    = ", bs_sign, " ", fSplitField (DoubleToStr (bd_Pribul, 1)), " [ ", fSplitField (gia_HistoryOrders[2]), " | ", fSplitField (gia_HistoryOrders[0]), " / ", fSplitField (gia_HistoryOrders[1]), " ]\n",
                 ls_PSI,
                 //----  
                 ls_Comment,
                 //----  
                 ls_Error);//,
    //----      
    Comment (ls_BLOCK_Comment);
//----
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                                    |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fPrepareComments()
{
    string ls_txt;
//---- 
    if (ShowCommentInChart)
    {
        if (!OnlyCurrentSymbol)
        {
            string ls_ListSymbols = IIFs (List_Symbols == "", "  ", " :\n" + bs_SymbolList);
            if (NumberAccount > 0)
            {gs_Info = StringConcatenate ("   ", AccountNumber(), "   ", ls_ListSymbols);}
            if (NumberAccount == 0)
            {gs_Info = StringConcatenate ("      ", ls_ListSymbols);}
        }
        else
        {
            ls_ListSymbols = StringConcatenate ("c ", bs_SymbolList);
            if (NumberAccount > 0)
            {gs_Info = StringConcatenate ("   ", AccountNumber(), "    ", Symbol(), ".");}
            if (NumberAccount == 0)
            {gs_Info = StringConcatenate ("       ", Symbol(), ".");}
        }
        if (!ValueInCurrency)
        {gs_Base = StringConcatenate ("    .\nTrailProfit_ON = ", CheckBOOL (TrailProfit_ON), "; TrailProfit_StartPercent = ", DoubleToStr (TrailProfit_StartPercent, 1), " %; TrailProfit_LevelPercent = ", DoubleToStr (TrailProfit_LevelPercent, 1), " %",
        "\nTakeProfit_ON = ", CheckBOOL (TakeProfit_ON), "; TPPercent = ", DoubleToStr (TP_AdvisorPercent, 1), " %; StopLoss_ON = ", CheckBOOL (StopLoss_ON), "; SLPercent = ", DoubleToStr (SL_AdvisorPercent, 1), " %");}
        else {gs_Base = StringConcatenate ("   .\nTrailProfit_ON = ", CheckBOOL (TrailProfit_ON), "; TrailProfit_Start = ", bs_sign, DS0 (TrailProfit_Start), "; TrailProfit_Level = ", bs_sign, DS0 (TrailProfit_Level),
        "\nTakeProfit_ON = ", CheckBOOL (TakeProfit_ON), "; TakeProfit = ", bs_sign, DS0 (TP_Advisor), "; StopLoss_ON = ", CheckBOOL (StopLoss_ON), "; StopLoss = ", bs_sign, DS0 (SL_Advisor));}
        gs_Base = StringConcatenate (gs_Base, "\n", IIFs ((NewBarInPeriod < 0), "   ", " : "));
    }
    if (ls_ListSymbols != "")
    {
        ls_txt = StringConcatenate ("   ", ls_ListSymbols);
        Print (ls_txt);
    }
    Print (IIFs ((MG == 0), "   MAGIC !!!", StringConcatenate ("   MAGIC = ", MG, " !!!")));
//---- 
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                  |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
bool fCheck_MyAccount()
{
//----
    if (NumberAccount > 0)
    {
        if (AccountNumber() != NumberAccount)
        {
            flag_BadAccount = true;
            Alert ("   ");
            return (false);
        }
    }      
//----
    return (true);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//+===================================================================================+
//|***********************************************************************************|
//| : TESTER                                                                    |
//|***********************************************************************************|
//+===================================================================================+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY, taras_bulba@tut.by                                              |
//+-----------------------------------------------------------------------------------+
//|                                                     |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fOrderSend_Tester()
{
//---- 
    if (!IsTesting()) return;
    static datetime ldt_NewBar = 0;
    datetime ldt_curBar = fGet_SymbolTime (Symbol(), PERIOD_H4, 0);
    if (OrdersTotal() < 3) if (ldt_NewBar != ldt_curBar)
    {
        if (fIs_LossLastPos()) {InTesterOrder = IIFi ((InTesterOrder == 1), -1, 1);}
        if (InTesterOrder == 1)
        {fOrderSend (Symbol(), OP_BUY, 0.6, NDD (Ask), 2, 0., 0., NULL, MathMax (MG, 0));}
        if (InTesterOrder == -1)
        {fOrderSend (Symbol(), OP_SELL, 0.6, NDD (Bid), 2, 0., 0., NULL, MathMax (MG, 0));}
        ldt_NewBar = ldt_curBar;
    }
//---- 
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+

